#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf ebtables-v2.0.10-4.tar.gz
    cd ebtables-v2.0.10-4
    ed -s Makefile >/dev/null << EOF
/^LOCKFILE?=/s/lib/run/
/^CFLAGS_SH_LIB:=/s/-O3/$CFLAGS/
w
q
EOF
    make static
    strip -R .note -R .comment static
    mkdir -p ../ebtables/sbin ../ebtables/etc
    cp static ../ebtables/sbin/ebtables
    cp ethertypes ../ebtables/etc/
    cd ..
    rm -rf ebtables-v2.0.10-4
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
